#!/bin/sh
. /root/gstreamer-examples/func.sh

init_dev
[ $? -ne 0 ] && exit 1

guess_param

echo " ================================================================================="
echo " starting gstreamer with monochrome (Y8 depend of camera typ) Source ..."
echo " read $SENSOR_RES (offset x,y=$OFFSET_SENSOR), convert and write to framebuffer"
echo " ================================================================================="
echo ""
echo " configure CSI1 (CAM1 port) with media_control"
echo " ================================================"

setup-pipeline-csi1 -f $CAM_BW_FMT -s $SENSOR_RES -o $OFFSET_SENSOR -c $SENSOR_RES


echo ""
echo " configure camera @CAM1 with v4l2_control"
echo " ========================================"

$V4L2_CTRL_CAM1_BW


echo ""
echo " start gstreamer, break with ctl-C"
echo " ================================="

gst-launch-1.0 \
	v4l2src device=$VID_DEVICE ! \
	video/x-raw,format=GRAY8,depth=8,$FRAME_SIZE ! \
	videoconvert n-threads=4 ! \
	queue ! waylandsink sync=false
