#!/bin/sh
. /root/gstreamer-examples/func.sh

init_dev
[ $? -ne 0 ] && exit 1

guess_param

SENSOR_RES_ROI="800x480"
FRAME_SIZE_ROI="width=800,height=480"
OFFSET_SENSOR="(240,164)"

echo " ================================================================================="
echo " starting gstreamer with $CAM_COL_FORMAT Source ..."
echo " read $SENSOR_RES_ROI (ROI in center of pic) convert bayer2rgb and write to framebuffer $SENSOR_RES_ROI"
echo " ================================================================================================"
echo ""
echo " configure CSI1 (CAM1 port) with media_control"
echo " ================================================"

setup-pipeline-csi1 -f $CAM_COL_FMT -s $SENSOR_RES_ROI -o $OFFSET_SENSOR -c $SENSOR_RES_ROI


echo ""
echo " configure camera @CAM1 with v4l2_control"
echo " ========================================"

$V4L2_CTRL_CAM1_COL
v4l2-ctl -d $CAM_DEVICE -c auto_exposure_max=480


echo ""
echo " start gstreamer, break with ctl-C"
echo " ================================="

gst-launch-1.0 \
	v4l2src device=$VID_DEVICE ! \
	video/x-$COL_FORMAT,$FRAME_SIZE_ROI ! \
	bayer2rgbneon ! \
	waylandsink sync=false
