#!/bin/sh
. /root/gstreamer-examples/func.sh

init_dev
[ $? -ne 0 ] && exit 1

guess_param

echo " starting gstreamer with $CAM_COL_FMT Source ..."
echo " read $SENSOR_RES (offset x,y=$OFFSET_SENSOR), encode2jpeg and write to file ar0144_col_image.jpg"
echo " ==========================================================================================="
echo ""
echo " configure CSI1 (CAM1 port) with media_control"
echo " ==============================================="

setup-pipeline-csi1 -f $CAM_COL_FMT -s $SENSOR_RES -o $OFFSET_SENSOR -c $SENSOR_RES


echo ""
echo " configure camera @CAM1 with v4l2_control"
echo " ========================================"

$V4L2_CTRL_CAM1_COL
v4l2-ctl -d $CAM_DEVICE -c auto_exposure_max=800


echo ""
echo " start gstreamer"
echo " ==============="

gst-launch-1.0 \
	v4l2src num-buffers=$NUMBER_OF_PIC device=$VID_DEVICE ! \
	video/x-$COL_FORMAT,$FRAME_SIZE ! \
	bayer2rgbneon ! \
	videoconvert ! \
	jpegenc ! \
	multifilesink location=ar0144_col_image.jpg