#!/bin/sh

VID_DEVICE="/dev/video-csi2"
CAM_DEVICE="/dev/cam-csi2"
CAM_ENT="$(cat /sys/class/video4linux/$(readlink /dev/cam-csi2)/name)"
CAM_NAME="$(echo ${CAM_ENT} | cut -d" " -f1)"
CAM_I2C_BUS="$(echo ${CAM_ENT} | cut -d" " -f2 | cut -b1)"
CAM_I2C_ADRESS="$(echo ${CAM_ENT} | cut -d" " -f2 | cut -b4-6)"

echo ""
echo " camera 2 = $CAM_NAME at i2c bus=$CAM_I2C_BUS with i2c adress=0x$CAM_I2C_ADRESS installed"
echo " capture device 2 @CAM2 = $(readlink -f /dev/video-csi2)"
echo " camera device 2 @CAM2 = $(readlink -f /dev/cam-csi2)"
echo " camera entity name 2 = $CAM_ENT"
echo " camera driver 2 = $CAM_NAME"
echo ""

if [ $CAM_NAME = "ar0144" ]; then
	source /usr/share/phytec-gstreamer-examples/ar0144.conf
elif [ $CAM_NAME = "ar0521" ]; then
	source /usr/share/phytec-gstreamer-examples/ar0521.conf
	SENSOR_RES="1920x1080"					# only 2MPix for ISI CAM2
	GRAB_RES="1920x1080"
	FRAME_SIZE="width=1920,height=1080"
	OFFSET_SENSOR="(336,432)"
else
	echo ""
	echo " camera at CAM2 connector not found"
	echo " no camera or more then one camera connected"
	echo " please check camera device tree"
	echo " please check connected camera type, i2c adress and cable connections"
	echo ""
	return 1
fi


echo " ================================================================================="
echo " starting gstreamer with Monochrome Source ..."
echo " read $SENSOR_RES (offset x,y=$OFFSET_SENSOR) and write to file bw_$CAMERA.raw"
echo " ====================================================================================="
echo ""
echo " configure CSI2 (CAM2 port) with media_control"
echo " ================================================"

setup-pipeline-csi2 -f $CAM_BW_FMT -s $SENSOR_RES -o $OFFSET_SENSOR -c $SENSOR_RES


echo ""
echo " configure camera @CAM2 with v4l2_control"
echo " ========================================"

$V4L2_CTRL_CAM1_BW



echo ""
echo " start gstreamer"
echo " ==============="

gst-launch-1.0 \
	v4l2src num-buffers=$NUMBER_OF_PIC device=$VID_DEVICE ! \
	video/x-raw,format=GRAY8,depth=8,$FRAME_SIZE ! \
	multifilesink location=bw_$CAMERA.raw

echo "File \"bw_$CAMERA.raw\" (Y8$SENSOR_SIZE)"