#!/bin/sh

VID_DEVICE_1="/dev/video-csi1"
CAM_DEVICE_1="/dev/cam-csi1"
CAM_ENT_1="$(cat /sys/class/video4linux/$(readlink /dev/cam-csi1)/name)"
CAM_NAME_1="$(echo ${CAM_ENT_1} | cut -d" " -f1)"
CAM_I2C_BUS_1="$(echo ${CAM_ENT_1} | cut -d" " -f2 | cut -b1)"
CAM_I2C_ADRESS_1="$(echo ${CAM_ENT_1} | cut -d" " -f2 | cut -b4-6)"

VID_DEVICE_2="/dev/video-csi2"
CAM_DEVICE_2="/dev/cam-csi2"
CAM_ENT_2="$(cat /sys/class/video4linux/$(readlink /dev/cam-csi2)/name)"
CAM_NAME_2="$(echo ${CAM_ENT_2} | cut -d" " -f1)"
CAM_I2C_BUS_2="$(echo ${CAM_ENT_2} | cut -d" " -f2 | cut -b1)"
CAM_I2C_ADRESS_2="$(echo ${CAM_ENT_2} | cut -d" " -f2 | cut -b4-6)"

echo ""
echo " camera 1 = $CAM_NAME_1 at i2c bus=$CAM_I2C_BUS_1 with i2c adress=0x$CAM_I2C_ADRESS_1 installed"
echo " capture device 1 @CAM1 = $(readlink -f /dev/video-csi1)"
echo " camera device 1 @CAM1 = $(readlink -f /dev/cam-csi1)"
echo " camera entity name 1 = $CAM_ENT_1"
echo " camera driver 1 = $CAM_NAME_1"
echo ""
echo " camera 2 = $CAM_NAME_2 at i2c bus=$CAM_I2C_BUS_2 with i2c adress=0x$CAM_I2C_ADRESS_2 installed"
echo " capture device 2 @CAM2 = $(readlink -f /dev/video-csi2)"
echo " camera device 2 @CAM2 = $(readlink -f /dev/cam-csi2)"
echo " camera entity name 2 = $CAM_ENT_2"
echo " camera driver 2 = $CAM_NAME_2"
echo ""


source /usr/share/phytec-gstreamer-examples/ar0144.conf
SENSOR_RES="1280x800"
FRAME_SIZE="width=1280,height=800"

echo " ================================================================================="
echo " starting gstreamer with two (CAM1 and CAM2) COLOR (YUV) Source after ISP ..."
echo " read from sensor $SENSOR_RES, read after ISP $FRAME_SIZE_FROM_ISP, convert and write to framebuffer"
echo " ================================================================================="
echo ""
echo " choose right XML-File and JSON-File in Sensor0/1_Entry.cfg"
echo " =========================================================="

sed -i 's/^mode= .*/mode= '$MODE_VAR_DEFAULT'/' $(readlink -f /opt/imx8-isp/bin/Sensor0_Entry.cfg)
XML_FILE1=`grep -A1 mode.$MODE_VAR_DEFAULT /opt/imx8-isp/bin/Sensor0_Entry.cfg | grep xml | cut -c12- | sed 's/"//g'`
JSON_FILE1=`grep -A2 mode.$MODE_VAR_DEFAULT /opt/imx8-isp/bin/Sensor0_Entry.cfg | grep json | cut -c12- | sed 's/"//g'`
echo " XML_File1 for ISP at CAM1  = $XML_FILE1"
echo " JSON_File1 for ISP at CAM1 = $JSON_FILE1"

sed -i 's/^mode= .*/mode= '$MODE_VAR_DEFAULT'/' $(readlink -f /opt/imx8-isp/bin/Sensor1_Entry.cfg)
XML_FILE2=`grep -A1 mode.$MODE_VAR_DEFAULT /opt/imx8-isp/bin/Sensor1_Entry.cfg | grep xml | cut -c12- | sed 's/"//g'`
JSON_FILE2=`grep -A2 mode.$MODE_VAR_DEFAULT /opt/imx8-isp/bin/Sensor1_Entry.cfg | grep json | cut -c12- | sed 's/"//g'`
echo " XML_File2 for ISP at CAM2  = $XML_FILE2"
echo " JSON_File2 for ISP at CAM2 = $JSON_FILE2"

echo ""
echo " configure CSI1 (CAM1 port) with media_control"
echo " ============================================="

if [ -e /dev/phycam-deserializer-csi1 ] && [ -e /dev/phycam-serializer-csi1 ] ; then
	DESERIALIZER="$(cat /sys/class/video4linux/$(readlink /dev/phycam-deserializer-csi1)/name)"
	SERIALIZER="$(cat /sys/class/video4linux/$(readlink /dev/phycam-serializer-csi1)/name)"
	media-ctl -l "'${SERIALIZER}':1->'${DESERIALIZER}':0[1]"
fi

if [ -e /dev/phycam-deserializer-csi2 ] && [ -e /dev/phycam-serializer-csi2 ] ; then
	DESERIALIZER="$(cat /sys/class/video4linux/$(readlink /dev/phycam-deserializer-csi2)/name)"
	SERIALIZER="$(cat /sys/class/video4linux/$(readlink /dev/phycam-serializer-csi2)/name)"
	media-ctl -l "'${SERIALIZER}':1->'${DESERIALIZER}':0[1]"
fi


echo ""
echo " configure camera @CAM1 with v4l2_control"
echo " ========================================"

if [ "$(v4l2-ctl -d /dev/cam-csi1 --get-subdev-fmt 0 | grep "Mediabus Code" | sed 's/.*BUS_FMT_\([A-Z]*\).*/\1/g')" = "Y" ]; then
	V4L2_CTRL_CAM_BW_ISP="v4l2-ctl -d $(readlink -f /dev/cam-csi1) ${V4L2_CTRL_CAM1_BW_ISP:13}"
	$V4L2_CTRL_CAM_BW_ISP
	V4L2_CTRL_CAM_BW_ISP="v4l2-ctl -d $(readlink -f /dev/cam-csi2) ${V4L2_CTRL_CAM1_BW_ISP:13}"
	$V4L2_CTRL_CAM_BW_ISP
else
	V4L2_CTRL_CAM_COL_ISP="v4l2-ctl -d $(readlink -f /dev/cam-csi1) ${V4L2_CTRL_CAM1_COL_ISP:13}"
	$V4L2_CTRL_CAM_COL_ISP
	V4L2_CTRL_CAM_COL_ISP="v4l2-ctl -d $(readlink -f /dev/cam-csi2) ${V4L2_CTRL_CAM1_COL_ISP:13}"
	$V4L2_CTRL_CAM_COL_ISP
fi


echo ""
echo " start gstreamer"
echo " ==============="

gst-launch-1.0 videomixer name=mix sink_0::xpos=0 sink_0::ypos=0 sink_1::xpos=1280 sink_1::ypos=0 ! waylandsink sync=false \
	v4l2src device=$VID_DEVICE_1 ! \
	video/x-raw,format=YUY2,$FRAME_SIZE,framerate=20/1 ! mix. \
	v4l2src device=$VID_DEVICE_2 ! \
	video/x-raw,format=YUY2,$FRAME_SIZE,framerate=20/1 ! mix.