#!/bin/sh

VID_DEVICE="/dev/video-csi2"
CAM_DEVICE="/dev/cam-csi2"
CAM_ENT="$(cat /sys/class/video4linux/$(readlink /dev/cam-csi2)/name)"
CAM_NAME="$(echo ${CAM_ENT} | cut -d" " -f1)"
CAM_I2C_BUS="$(echo ${CAM_ENT} | cut -d" " -f2 | cut -b1)"
CAM_I2C_ADRESS="$(echo ${CAM_ENT} | cut -d" " -f2 | cut -b4-6)"

echo ""
echo " camera 2 = $CAM_NAME at i2c bus=$CAM_I2C_BUS with i2c adress=0x$CAM_I2C_ADRESS installed"
echo " capture device 2 @CAM2 = $(readlink -f /dev/video-csi2)"
echo " camera device 2 @CAM2 = $(readlink -f /dev/cam-csi2)"
echo " camera entity name 2 = $CAM_ENT"
echo " camera driver 2 = $CAM_NAME"
echo ""

if [ $CAM_NAME = "ar0144" ]; then
	source /usr/share/phytec-gstreamer-examples/ar0144.conf
elif [ $CAM_NAME = "ar0521" ]; then
	source /usr/share/phytec-gstreamer-examples/ar0521.conf
else
	echo ""
	echo " camera at CAM2 connector not found"
	echo " no camera or more then one camera connected"
	echo " please check camera device tree"
	echo " please check connected camera type, i2c adress and cable connections"
	echo ""
	return 1
fi


echo " ================================================================================="
echo " starting gstreamer with COLOR or MONOCHROME Source ..."
echo " read $SENSOR_RES (offset x,y=$OFFSET_SENSOR), convert and write to framebuffer"
echo " ================================================================================="
echo ""
echo " choose right XML-File and JSON-File in Sensor0_Entry.cfg"
echo " ========================================================"

sed -i 's/^mode= .*/mode= '$MODE_VAR_DEFAULT'/' $(readlink -f /opt/imx8-isp/bin/Sensor1_Entry.cfg)
XML_FILE=`grep -A1 mode.$MODE_VAR_DEFAULT /opt/imx8-isp/bin/Sensor1_Entry.cfg | grep xml | cut -c12- | sed 's/"//g'`
JSON_FILE=`grep -A2 mode.$MODE_VAR_DEFAULT /opt/imx8-isp/bin/Sensor1_Entry.cfg | grep json | cut -c12- | sed 's/"//g'`
echo " XML_File for ISP  = $XML_FILE"
echo " JSON_File for ISP = $JSON_FILE"


echo ""
echo " configure CSI2 (CAM2 port) with media_control"
echo " ============================================="

if [ -e /dev/phycam-deserializer-csi2 ] && [ -e /dev/phycam-serializer-csi2 ] ; then
	DESERIALIZER="$(cat /sys/class/video4linux/$(readlink /dev/phycam-deserializer-csi2)/name)"
	SERIALIZER="$(cat /sys/class/video4linux/$(readlink /dev/phycam-serializer-csi2)/name)"
	media-ctl -l "'${SERIALIZER}':1->'${DESERIALIZER}':0[1]"
fi


echo ""
echo " configure camera @CAM2 with v4l2_control"
echo " ========================================"

if [ "$(v4l2-ctl -d /dev/cam-csi1 --get-subdev-fmt 0 | grep "Mediabus Code" | sed 's/.*BUS_FMT_\([A-Z]*\).*/\1/g')" = "Y" ]; then
	$V4L2_CTRL_CAM1_BW_ISP
else
	$V4L2_CTRL_CAM1_COL_ISP
fi


echo ""
echo " start gstreamer, break with ctl-C"
echo " ================================="

gst-launch-1.0 \
	v4l2src device=$VID_DEVICE ! \
	video/x-raw,format=YUY2,$FRAME_SIZE ! \
	waylandsink sync=false
