#!/bin/sh

. /root/gstreamer-examples/func.sh

init_dev
[ $? -ne 0 ] && exit 1

guess_param

echo " pixel depth"
echo " ================="
echo " 1 = 8-Bit"
echo " 2 = 10-Bit"
echo " 3 = 12-Bit"
read PIX_DEPTH
echo " Your select = $PIX_DEPTH"
case $PIX_DEPTH in
  "1") CAM_COL_FMT="SGRBG8_1X8"; CAM_BW_FMT="Y8_1X8";;
  "2") CAM_COL_FMT="SGRBG10_1X10"; CAM_BW_FMT="Y10_1X10";;
  "3") CAM_COL_FMT="SGRBG12_1X12"; CAM_BW_FMT="Y12_1X12";;
  *) CAM_COL_FMT="SGRBG8_1X8"; CAM_BW_FMT="Y8_1X8";;
esac

echo ""
echo " configure CSI1 (CAM1 port) with media_control"
echo " ============================================="
echo " and configure camera @CAM1 with v4l2_control"
echo " ============================================"

if [ "$(v4l2-ctl -d /dev/cam-csi1 --get-subdev-fmt 0 | grep "Mediabus Code" | sed 's/.*BUS_FMT_\([A-Z]*\).*/\1/g')" = "Y" ]; then
	setup-pipeline-csi1 -f $CAM_BW_FMT -s $SENSOR_RES -o $OFFSET_SENSOR -c $SENSOR_RES
	$V4L2_CTRL_CAM1_BW
	CAM_FMT=${CAM_BW_FMT%%_*}
	X_RES=${SENSOR_RES%%x*}
	Y_RES=${SENSOR_RES##*x}
else
	setup-pipeline-csi1 -f $CAM_COL_FMT -s $SENSOR_RES -o $OFFSET_SENSOR -c $SENSOR_RES
	$V4L2_CTRL_CAM1_COL
	CAM_FMT=${CAM_COL_FMT%%_*}
	X_RES=${SENSOR_RES%%x*}
	Y_RES=${SENSOR_RES##*x}
fi

if [ "$CAM_NAME" = "ar0144" ]; then
    CAPTURE_COUNT=8
	SKIP_COUNT=7
else
    CAPTURE_COUNT=1
	SKIP_COUNT=0
fi


echo " starting save_raw_image with format $COL_FMT"
echo " read $X_RES x $Y_RES and write to RAW-file"
echo " ============================================="

yavta "$VID_DEVICE" -c$CAPTURE_COUNT --skip $SKIP_COUNT -f "$CAM_FMT" -s "${X_RES}x${Y_RES}" -F$CAMERA_TYP"_PixDepth_"$CAM_FMT".raw"
