#!/bin/sh
. /root/gstreamer-examples/func.sh

init_dev
[ $? -ne 0 ] && exit 1

echo " ================================================================================="
echo " starting with COLOR (YUV) Source after ISP ..."
echo " read $SENSOR_RES (offset x,y=$OFFSET_SENSOR) and write with YAVTA"
echo " ================================================================================="
cho ""
echo " choose right XML-File and JSON-File in Sensor0_Entry.cfg"
echo " ========================================================"

sed -i 's/^mode= .*/mode= '$MODE_VAR_DEFAULT'/' $(readlink -f /opt/imx8-isp/bin/Sensor0_Entry.cfg)
XML_FILE=`grep -A1 mode.$MODE_VAR_DEFAULT /opt/imx8-isp/bin/Sensor0_Entry.cfg | grep xml | cut -c12- | sed 's/"//g'`
JSON_FILE=`grep -A2 mode.$MODE_VAR_DEFAULT /opt/imx8-isp/bin/Sensor0_Entry.cfg | grep json | cut -c12- | sed 's/"//g'`
echo " XML_File for ISP  = $XML_FILE"
echo " JSON_File for ISP = $JSON_FILE"


echo ""
echo " configure CSI1 (CAM1 port) with media_control"
echo " ============================================="

if [ -e /dev/phycam-deserializer-csi1 ] && [ -e /dev/phycam-serializer-csi1 ] ; then
	DESERIALIZER="$(cat /sys/class/video4linux/$(readlink /dev/phycam-deserializer-csi1)/name)"
	SERIALIZER="$(cat /sys/class/video4linux/$(readlink /dev/phycam-serializer-csi1)/name)"
	media-ctl -l "'${SERIALIZER}':1->'${DESERIALIZER}':0[1]"
fi


echo ""
echo " configure camera @CAM1 with v4l2_control"
echo " ========================================"

if [ "$(v4l2-ctl -d /dev/cam-csi1 --get-subdev-fmt 0 | grep "Mediabus Code" | sed 's/.*BUS_FMT_\([A-Z]*\).*/\1/g')" = "Y" ]; then
	$V4L2_CTRL_CAM1_BW_ISP
else
	$V4L2_CTRL_CAM1_COL_ISP
fi


# Additional Settings
COL_FMT=YUYV
X_RES=${SENSOR_RES%%x*}
Y_RES=${SENSOR_RES##*x}


echo " starting save_raw_image with format $COL_FMT"
echo " read $X_RES x $Y_RES and write to RAW-file"
echo " ============================================="

yavta "$VID_DEVICE" -c31 --skip 30 -f "$COL_FMT" -s "${X_RES}x${Y_RES}" -F$CAM_NAME"_col_fmt_"$COL_FMT".raw"

